hdu 5348 MZL's endless loop 欧拉回路

MZL‘s endless loop

Time Limit: 3000/1500 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)
Total Submission(s): 1502    Accepted Submission(s): 331
Special Judge

Problem Description

As we all kown, MZL hates the endless loop deeply, and he commands you to solve this problem to end the loop.
You are given an undirected graph with n vertexs and m edges. Please direct all the edges so that for every vertex in the graph the inequation |out degree − in degree|≤1 is satisified.
The graph you are given maybe contains self loops or multiple edges.

Input

The first line of the input is a single integer T, indicating the number of testcases.
For each test case, the first line contains two integers n and m.
And the next m lines, each line contains two integers ui and vi, which describe an edge of the graph.
T≤100, 1≤n≤105, 1≤m≤3∗105, ∑n≤2∗105, ∑m≤7∗105.

Output

For each test case, if there is no solution, print a single line with −1, otherwise output m lines,.
In ith line contains a integer 1 or 0, 1 for direct the ith edge to ui→vi, 0 for ui←vi.

Sample Input

2 3 3 1 2 2 3 3 1 7 6 1 2 1 3 1 4 1 5 1 6 1 7

Sample Output

1 1 1 0 1 0 1 0 1

Source

2015 Multi-University Training Contest 5

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5348

题目大意:将一个无向图构造出一个有向图,要求每个点的入度和出度之差绝对值不超过1。

思路,重点在于删边,边表删边相对于vector存储而言更方便一些,因为.next自带边号,每次把head[],以i为起点的第一条边存储的位置(实际上是最后输入的那条边的边号)改为edge[i].next,即实现了“拆边”。

AC代码:

1 #include <iostream>
 2 #include <cstdio>
 3 #include <cmath>
 4 #include <cstring>
 5 #include <algorithm>
 6 #include <vector>
 7 using namespace std;
 8 #define MAXN 100010
 9 #define MAXM 300010
10 int t, n, m;
11 int targ[MAXN][2];
12 int degree[MAXN], ans[MAXM << 1];
13 int head[MAXN], edge_cnt;
14 struct node {
15     int v, next;
16 } edge[MAXM << 1];
17 void init() {
18     memset(head, -1, sizeof head);
19     memset(degree, 0, sizeof degree);
20     memset(targ, 0, sizeof targ);
21     memset(ans, -1, sizeof ans);
22     edge_cnt = 0;
23 }
24 void add_edge(int u, int v) {
25     edge[edge_cnt].v = v;
26     edge[edge_cnt].next = head[u];
27     head[u] = edge_cnt++;
28 }
29 void DFS(int u, int col) {
30     for(int i = head[u]; ~i; i = edge[i].next) {
31         if(ans[i] != -1) {
32             head[u] = edge[i].next;//拆边
33             continue;
34         }
35         int v = edge[i].v;
36         if(u != v && targ[v][col ^ 1] > targ[v][col]) continue;
37         ans[i] = col;
38         ans[i ^ 1] = col ^ 1;
39         head[u] = edge[i].next;
40         targ[u][col]++;
41         targ[v][col ^ 1]++;
42         DFS(v, col);
43         break;
44     }
45 }
46 int main() {
47     scanf("%d", &t);
48     while(t--) {
49         scanf("%d%d", &n, &m);
50         init();
51         int a, b;
52         for(int i = 1; i <= m; i++) {
53             scanf("%d%d", &a, &b);
54             add_edge(a, b);
55             add_edge(b, a);
56             degree[a]++; degree[b]++;
57         }
58         for(int i = 1; i <= n; i++) {
59             while(targ[i][0] + targ[i][1] < degree[i]) {
60                 if(targ[i][0] < targ[i][1]) DFS(i, 0);
61                 else DFS(i, 1);
62             }
63         }
64         for(int i = 0; i < edge_cnt; i += 2) {
65             printf("%d\n", ans[i]);
66         }
67     }
68     return 0;
69 }

hdu 5348 MZL's endless loop 欧拉回路

时间: 2024-11-13 22:25:33

hdu 5348 MZL's endless loop 欧拉回路的相关文章

HDU 5348 MZL&#39;s endless loop 给边定向(欧拉回路,最大流)

题意:给一个所有你可能想得到的奇葩无向图,要求给每条边定向,使得每个点的入度与出度之差不超过1.输出1表示定向往右,输出0表示定向往左. 思路: 这题本来很简单的事,在每两个奇数度的点添加1条无向边,就变成了个欧拉回路了.欧拉回路的定义时,只要每个点的度为偶数,必定有欧拉回路的存在.只需要选择任1个点出发,遍历每条边仅1次,得到就是欧拉回路路径了,再根据每条边的方向选0/1.添加的那些无向边都是不会影响答案的,因为欧拉回路跑得起来肯定是每个点的出度等于入度,而每个点最多只会被多加1条边,根据题目

【搜索】HDU 5348 MZL&#39;s endless loop

通道 题意:给出n个点,m条边,现在要给边定向使得点的出度和入度的差不超过1 思路: 对每个点进行出度和入度的判断,如果出度大,就先进行反向的搜索(每搜索一条边u,v就认为这是一条v到u的有向边),反之,进行正向搜索(每搜到一条边u,v认为这是一条u到v的有向边),一直搜索到找不到边能继续为止,每条边只遍历一次 代码: #pragma comment(linker, "/STACK:102400000,102400000") #include <cstdio> #inclu

HDU 5348 MZL&#39;s endless loop

乱搞题...第一直觉是混合图的欧拉通路,但是感觉并没有多大关系.最终AC的做法是不断的寻找欧拉通路,然后给边标号.所有边访问了一遍,所有点访问了一遍,效率是o(n+m).不存在-1的情况. #include<cstdio> #include<cstring> #include<cmath> #include<vector> #include<algorithm> using namespace std; const int maxn=100000

hdu 5348 MZL&#39;s endless loop 暴搜

链接:http://acm.hdu.edu.cn/showproblem.php?pid=5348 MZL's endless loop Time Limit: 3000/1500 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others) Total Submission(s): 1426    Accepted Submission(s): 319 Special Judge Problem Description As w

Hdu 5348 MZL&#39;s endless loop (dfs)

题目链接: Hdu 5348 MZL's endless loop 题目描述: 给出一个无向图(有环,有重边),包含n个顶点,m条边,问能否给m条边指定方向,使每个顶点都满足abs(出度-入度)<2.如果能输出任意一种合法方案. 解题思路: 其实仔细考虑一下,每个无向图都会存在合法方案的.证明:度数和为奇数的点只能为起点或者终点,度数为偶数的只能是环上的起点或者终点或者是中间点.有m条边,一共有2*m个端点.所以呢?当然是度数和为奇数的个肯定是偶数个,任意两个相结合都可以形成一条路.并不会有两条

HDU 5348 MZL&#39;s endless loop(思想用的是深搜)经典

MZL's endless loop Time Limit: 3000/1500 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others) Total Submission(s): 1343    Accepted Submission(s): 282 Special Judge Problem Description As we all kown, MZL hates the endless loop deeply, and

图论 HDOJ 5348 MZL&#39;s endless loop

题目传送门 1 /* 2 题意:给一个n个点,m条边的无向图,要求给m条边定方向,使得每个定点的出入度之差的绝对值小于等于1. 输出任意一种结果 3 图论:一个图,必定存在偶数个奇度顶点.那么从一个奇度定点深搜,当碰到另外一个奇度顶点时结束,这样能保证度数差<=1 3.5 详细解释:http://blog.csdn.net/ZSGG_ACM/article/details/47287681 4 */ 5 /*********************************************

hdu5348 MZL&#39;s endless loop(欧拉回路)

转载请注明出处: http://www.cnblogs.com/fraud/          ——by fraud MZL's endless loop Time Limit: 3000/1500 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)Total Submission(s): 1705    Accepted Submission(s): 369Special Judge Problem Descripti

MZL&#39;s endless loop(欧拉回路,欧拉路径)

MZL's endless loop Time Limit: 3000/1500 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others) Total Submission(s): 751    Accepted Submission(s): 138 Special Judge Problem Description As we all kown, MZL hates the endless loop deeply, and